//
// 萔`
//

#define PLUGIN_API __declspec(dllexport)


// C[̏C@
enum LayerModify
{
	// CȂ
	LayerModifyNone = 0,

	// C[폜
	LayerModifyRemove,

	// C[}
	LayerModifyInsert

};

// C[̉Z@
enum LayerCalc
{
	// ʏ
	LayerCalcNormal = 0,

	// Z
	LayerCalcMultiply,

	// Z
	LayerCalcAdd,

	// Z
	LayerCalcSubtract,

	// XN[
	LayerCalcScreen,

	// I[o[C
	LayerCalcOverlay,

	// \tgCg
	LayerCalcSoftLight,

	// n[hCg
	LayerCalcHardLight,

	// Ă
	LayerCalcDodge,

	// Ă
	LayerCalcBurn,

	// rij
	LayerCalcBright,

	// riÁj
	LayerCalcDark,

	// ̐Βl
	LayerCalcDifference

};


//
// \̒`
//

//
// [hsNZ\
//
typedef struct WordPixel
{
	enum
	{
		// l̍ŏl
		ValueMin = 0,

		// l̍ől
		ValueMax = (255 << 8)
	};

	// 
	WORD r;

	// 
	WORD g;

	// 
	WORD b;

	// 
	WORD a;

	//
	// RXgN^
	//
	WordPixel()
	{
	}

	//
	// RXgN^
	// colorFF
	//
	WordPixel(COLORREF color)
		: r(GetRValue(color) << 8),
		  g(GetGValue(color) << 8),
		  b(GetBValue(color) << 8),
		  a(ValueMax)
	{
	}

	//
	// RXgN^
	// rFԗvf
	// gFΗvf
	// bFvf
	// aFAt@vf
	//
	WordPixel(WORD r, WORD g, WORD b, WORD a)
		: r(r),
		  g(g),
		  b(b),
		  a(a)
	{
	}

	//
	// F
	// colorFF
	// alphaFAt@l̍XVsȂtrue(ftHg)AsȂȂfalse
	//
	void Blend(const WordPixel& color, bool alpha = true)
	{
		if (color.a > 0)
		{
			double sa = (double)color.a / ValueMax;
			double da = (double)a / ValueMax;
			double na = sa + da - sa * da;
			double m = da * (1.0 - sa);
			double d = 1.0 / na;
			r = (WORD)((color.r * sa + (double)r * m) * d);
			g = (WORD)((color.g * sa + (double)g * m) * d);
			b = (WORD)((color.b * sa + (double)b * m) * d);
			if (alpha)
			{
				a = (WORD)(na * ValueMax);
			}
		}
	}

} WordPixel;


//
// pXuV\
//
typedef struct PathBrush
{
	// uV̎
	enum BrushType
	{
		// ۃuV
		BrushTypeCircle = 0,

		// p^[uV
		BrushTypePattern,

		// ^CuV
		BrushTypeTile,

		// uV̎ސ
		BrushTypeMax
	};

	enum
	{
		// uV̒a̗h炬̍ŏl
		BrushSizeJitterMin = 0,

		// uV̒a̗h炬̍ŏl
		BrushSizeJitterMax = 100,

		// uV̕`Ԋu̍ŏl
		BrushBetweenMin = 1,

		// uV̕`Ԋu̍ől
		BrushBetweenMax = 400,

		// uV̕`Ԋu͈̔(0.0`BrushBetweenRange)
		BrushBetweenRange = 2,

		// uV̔Zx̍ŏl
		BrushAlphaMin = 1,

		// uV̔Zx̍ől
		BrushAlphaMax = 100,

		// uV̍ŏZx̍ŏl
		BrushAlphaMinMin = 0,

		// uV̍ŏZx̍ől
		BrushAlphaMinMax = BrushAlphaMax,

		// uV̂ڂʒu̍ŏl
		BrushGradationMin = 0,

		// uV̂ڂʒu̍ől
		BrushGradationMax = 100,

		// `px̍ŏl
		BrushAngleMin = -180,

		// `px̍ől
		BrushAngleMax = 180,

		// `px̗h炬̍ŏl
		BrushAngleJitterMin = 0,

		// `px̗h炬̍ől
		BrushAngleJitterMax = 180,

		// ^CuṼXP[l̍ŏl
		TileBrushScaleMin = -100,

		// ^CuṼXP[l̍ŏl
		TileBrushScaleMax = 100

	};

	// a̍ŏl
	float sizeMin;

	// a̍ől
	float sizeMax;

	// a̗h炬
	int sizeJitter;

	// At@̍ŏl
	int alphaMin;

	// At@̍ől
	int alphaMax;

	// `Ԋu
	int between;

	// MTCY𗘗pȂTRUE
	BOOL pressSize;

	// MZx𗘗pȂTRUE
	BOOL pressAlpha;

	// d˓h肷ȂTRUE
	BOOL recoating;

	// ڂȂTRUEAڂȂȂFALSE
	BOOL gradation;

	// ڂ̊Jnʒu(0`100)
	int gradationStart;

	// `px()
	int angle;

	// `px̗h炬()
	int angleJitter;

	// `Ɋpx킹ꍇTRUE
	BOOL angleMove;

	// uV̎
	int type;

	// p^[ID(eNX`Xgɂ摜IDAǂݍݎɉ摜Ȃ΃eNX`̃uVƂĈ)
	DWORD patternID;

	// ^C摜̃XP[l(-100:1/2`+100:x2)
	int tileScale;

	//
	// RXgN^
	//
	PathBrush()
	{
	}

} PathBrush;


//
// pX_\
//
typedef struct PathCP
{
	// _̎
	enum Type
	{
		// Ώ
		TypeSymmetry = 0,

		// 炩
		TypeSmooth,

		// 炷
		TypeSharp,

		// [_
		TypeEdge,

		// _̎ނ̍ő吔
		TypeMax
	};

	// _̈ʒu
	float posX, posY;

	// O̐_ւ̕xNg
	float inDirX, inDirY;

	// ̐_ւ̕xNg
	float outDirX, outDirY;

	// `̗Ɏg
	DWORD randSeed;

	// `F
	DWORD drawColor;

	// _̎
	int type;

	// O̐_ւ̕Mʂ̎
	int inPEType;

	// O̐_ւ̕Mʂ̈ʒu
	int inPEPlace;

	// ̐_ւ̕Mʂ̎
	int outPEType;

	// ̐_ւ̕Mʂ̈ʒu
	int outPEPlace;

	// ̐܂ł𒼐ɂȂTRUE
	BOOL line;

	// ̐܂ł\ɂȂTRUE
	BOOL hide;

	// pXuVID
	int brushId;

	//
	// RXgN^
	//
	PathCP()
	{
	}

} PathCP;


//
// pXhԂ\
//
typedef struct PathFill
{
	// hԂ̕@
	enum FillMethod
	{
		// h薳
		FillMethodNone = 0,

		// PFh
		FillMethodSolid,

		// uVh
		FillMethodBrush,

		// Of[Vh
		FillMethodGradation,

		// hԂ̕@
		FillMethodMax

	};

	// hԂ̈̎
	enum FillRegion
	{
		// 
		FillRegionInvalid = -1,

		// pX̓
		FillRegionPath = 0,

		// uV̓
		FillRegionBrushInner,

		// uV̒
		FillRegionBrushMiddle,

		// uV̊O
		FillRegionBrushOuter,

		// uV̓}XN
		FillRegionBrushInnerMask,

		// uV̊O}XN
		FillRegionBrushOuterMask,

		// hԂ̈̎ސ
		FillRegionMax

	};

	// Of[V@
	enum GradationType
	{
		// `
		GradationTypeLinear = 0,

		// ~`
		GradationTypeCircular,

		// o`
		GradationTypeBilinear,

		// `
		GradationTypeSquare,

		// ֊s
		GradationTypeEdge,

		// Of[V@̐
		GradationTypeMax
	};

	// h̕@
	int fillMethod;

	// ḧ̗
	int fillRegion;

	// h̗̎
	DWORD fillSeed;

	// hF
	DWORD fillColor;

	// Of[V@
	int gradationType;

	// Of[V̎n_
	float gradationSrcX, gradationSrcY;

	// Of[V̏I_
	float gradationDestX, gradationDestY;

	// ֊s̋
	float gradationDist;

	// Of[V͈̔
	float gradationRange;

	// Of[V̕sx
	int gradationSrcAlpha;

	// Of[V̐FAgpȂꍇ̓At@0
	DWORD gradationDestColor;

	// Of[V̕sx
	int gradationDestAlpha;

	// Of[V𔽓]Ȃtrue
	BOOL gradationReverse;

	// uVID
	int brushId;

	//
	// RXgN^
	//
	PathFill()
	{
	}

} PathFill;


//
// ֐`
//

// vOC

PLUGIN_API const char* PluginGetName(const char* param);


// t@CvOC

PLUGIN_API const char* FilePluginGetExt(const char* param);
PLUGIN_API void* LoaderPluginPrepare(const char* param, const char* filename, HWND parent, int* cancel, bool batch);
PLUGIN_API void* LoaderPluginPrepareMemory(const char* param, const void* data, int size, HWND parent, int* cancel, bool batch);
PLUGIN_API bool LoaderPluginGetInfo(const char* param, void* work, int* width, int* height, int* layer, DWORD* canvas);
PLUGIN_API bool LoaderPluginGetInfo2(const char* param, void* work, int* width, int* height, int* layer, DWORD* canvas, int* brush);
PLUGIN_API bool LoaderPluginGetPathBrush(const char* param, void* work, int brush, PathBrush* data);
PLUGIN_API bool LoaderPluginGetLayerInfo(const char* param, void* work, int layer, char* name, int* mode, int* alpha, int* visible, int* imageMask, int* alphaMask);
PLUGIN_API bool LoaderPluginGetLayerInfo2(const char* param, void* work, int layer, char* name, int* mode, int* alpha, int* visible, int* imageMask, int* alphaMask, int* group, int* subLayer);
PLUGIN_API bool LoaderPluginGetSubLayerInfo(const char* param, void* work, int layer, int subLayer, char* name, int* mode, int* alpha, int* visible, int* imageMask, int* alphaMask, int* group);
PLUGIN_API bool LoaderPluginGetSubLayerInfo2(const char* param, void* work, int layer, int subLayer, char* name, int* mode, int* alpha, int* visible, int* imageMask, int* alphaMask, int* group, int* pathCp);
PLUGIN_API bool LoaderPluginGetLayerPixel(const char* param, void* work, int layer, BYTE* pixel);
PLUGIN_API bool LoaderPluginGetLayerPixel2(const char* param, void* work, int layer, int subLayer, BYTE* pixel);
PLUGIN_API bool LoaderPluginGetPathCp(const char* param, void* work, int layer, int subLayer, int cp, PathCP* data);
PLUGIN_API bool LoaderPluginGetPathFill(const char* param, void* work, int layer, int subLayer, PathFill* data);
PLUGIN_API bool LoaderPluginDispose(const char* param, void* work);
PLUGIN_API void* SaverPluginBatchPrepare(const char* param, HWND parent, int* cancel);
PLUGIN_API bool SaverPluginBatchDispose(const char* param, void* batch);
PLUGIN_API void* SaverPluginPrepare(const char* param, const char* filename, int* merge, int* alpha, int* threshold, HWND parent, int* cancel, void* batch);
PLUGIN_API bool SaverPluginSetInfo(const char* param, void* work, int width, int height, int layer, DWORD canvas);
PLUGIN_API bool SaverPluginSetInfo2(const char* param, void* work, int width, int height, int layer, DWORD canvas, int brush);
PLUGIN_API bool SaverPluginSetPathBrush(const char* param, void* work, int brush, PathBrush* data);
PLUGIN_API bool SaverPluginSetLayerInfo(const char* param, void* work, int layer, const char* name, int mode, int alpha, int visible, int imageMask, int alphaMask);
PLUGIN_API bool SaverPluginSetLayerInfo2(const char* param, void* work, int layer, const char* name, int mode, int alpha, int visible, int imageMask, int alphaMask, int group, int subLayer);
PLUGIN_API bool SaverPluginSetSubLayerInfo(const char* param, void* work, int layer, int subLayer, const char* name, int mode, int alpha, int visible, int imageMask, int alphaMask, int group);
PLUGIN_API bool SaverPluginSetSubLayerInfo2(const char* param, void* work, int layer, int subLayer, const char* name, int mode, int alpha, int visible, int imageMask, int alphaMask, int group, int pathCp);
PLUGIN_API bool SaverPluginSetLayerPixel(const char* param, void* work, int layer, BYTE* pixel);
PLUGIN_API bool SaverPluginSetLayerPixel2(const char* param, void* work, int layer, int subLayer, BYTE* pixel);
PLUGIN_API bool SaverPluginSetPathCp(const char* param, void* work, int layer, int subLayer, int cp, PathCP* data);
PLUGIN_API bool SaverPluginSetPathFill(const char* param, void* work, int layer, int subLayer, PathFill* data);
PLUGIN_API bool SaverPluginDispose(const char* param, void* work, bool success);


// C[WvOC

typedef bool (CALLBACK *ImagePluginProcessCallback)(void);
PLUGIN_API bool ImagePluginIsSizeChange(const char* param);
PLUGIN_API bool ImagePluginIsBatchEnable(const char* param);
PLUGIN_API int ImagePluginGetPhase(const char* param);
PLUGIN_API void* ImagePluginBatchPrepare(const char* param, HWND parent, int* cancel);
PLUGIN_API bool ImagePluginBatchDispose(const char* param, void* batch);
PLUGIN_API void* ImagePluginPrepare(const char* param, int width, int height, int layer, int current, HWND parent, int* cancel, void* batch);
PLUGIN_API void* ImagePluginPrepare2(const char* param, int width, int height, int layer, int currentLayer, int currentSubLayer, DWORD drawColor, DWORD bgColor, bool size, HWND parent, int* cancel, void* batch);
PLUGIN_API int ImagePluginDialog(const char* param, void* work, ImagePluginProcessCallback process);
PLUGIN_API int ImagePluginPhase(const char* param, void* work, int phase, int* width, int* height, WordPixel* merge, BYTE* selRatio, RECT* selRect);
PLUGIN_API int ImagePluginPhase2(const char* param, void* work, int phase, int* width, int* height, WordPixel* merge, BYTE* selRatio, RECT* selRect, int* readOnly);
PLUGIN_API bool ImagePluginExecute(const char* param, void* work, int phase, int layer, int group, WordPixel* destPixel, RECT* destRect, WordPixel* srcPixel, RECT* srcRect, bool adjust, int* modify);
PLUGIN_API bool ImagePluginExecute2(const char* param, void* work, int phase, int layer, int group, WordPixel* destPixel, RECT* destRect, WordPixel* srcPixel, RECT* srcRect, bool adjust, int* modify, int* visible);
PLUGIN_API bool ImagePluginExecute3(const char* param, void* work, int phase, int layer, int subLayer, int group, WordPixel* destPixel, RECT* destRect, WordPixel* srcPixel, RECT* srcRect, bool adjust, int* modify, int* visible);
PLUGIN_API bool ImagePluginExecute4(const char* param, void* work, int phase, int layer, int subLayer, int group, WordPixel* destPixel, RECT* destRect, WordPixel* srcPixel, RECT* srcRect, bool adjust, int* modify, int* visible, int* calc, int* alpha, int* mask, char* name);
PLUGIN_API void ImagePluginAdjustScale(const char* param, void* work, int phase, int layer, double* x, double* y);
PLUGIN_API bool ImagePluginAdjustLocate(const char* param, void* work, int phase, int layer, double* x, double* y);
PLUGIN_API bool ImagePluginAdjustLocate2(const char* param, void* work, int phase, int layer, int subLayer, double* x, double* y);
PLUGIN_API bool ImagePluginDispose(const char* param, void* work);


// tB^vOC

typedef bool (CALLBACK *FilterPluginProcessCallback)(void);
typedef bool (CALLBACK *FilterPluginSaveRerunDataCallback)(int, void*);
PLUGIN_API void* FilterPluginBatchPrepare(const char* param, HWND parent, int* cancel);
PLUGIN_API bool FilterPluginBatchDispose(const char* param, void* batch);
PLUGIN_API void* FilterPluginPrepare(const char* param, int width, int height, int layer, HWND parent, int* cancel, void* batch);
PLUGIN_API int FilterPluginDialog(const char* param, void* work, FilterPluginProcessCallback process);
PLUGIN_API bool FilterPluginExecute(const char* param, void* work, WordPixel* destPixel, RECT* destRect, WordPixel* srcPixel, RECT* srcRect, WordPixel*, int* create, int* insert);
PLUGIN_API bool FilterPluginDispose(const char* param, void* work);


